/*
 * Export the node from the global mfo array to which the number points.
 */
function exportMFO(number, send_bluetooth) 
{
	var output, ios, file, fileHandler, url, foStream;

	var processor = new XSLTProcessor();
	var serializer = new XMLSerializer();

	var docXML = document.implementation.createDocument('', '', null);
	var docXSL = document.implementation.createDocument('', '', null);

	/* Load MFO xml. Clone otherwise it will be replaced in the document! */
	docXML.appendChild(__tailsMFO[number].xml.cloneNode(true));

	/* Load stylesheet, only when completly loaded continue */
	docXSL.async = false;
	docXSL.load(__tailsMFO[number].xsl);
	
	processor.importStylesheet(docXSL);
  processor.setParameter( null, 'Source', __tailsSource );

	/* transform and serialize to string */
	output = serializer.serializeToString(processor.transformToFragment(docXML, document) );
  output = output.replace( /[\n\r]+/g, "\r\n" );

  	//if( getDefault("showExportResult") && getDefault("showExportResult") != 'false' ) { alert(output); }

	/* output string to file */
	file = Components.classes["@mozilla.org/file/directory_service;1"]
                     .getService(Components.interfaces.nsIProperties)
                     .get("TmpD", Components.interfaces.nsIFile);

	file.append("export."+__tailsMFO[number].ext);

	if (!file.exists()) {
		file.create(Components.interfaces.nsIFile.NORMAL_FILE_TYPE, 0664);
	}

	var ios = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
	var fileHandler = ios.getProtocolHandler("file").QueryInterface(Components.interfaces.nsIFileProtocolHandler);
	var url = fileHandler.getURLSpecFromFile(file);
	var foStream = Components.classes["@mozilla.org/network/file-output-stream;1"].createInstance(Components.interfaces.nsIFileOutputStream);

	// use 0x02 | 0x10 to open file for appending.
	foStream.init(file, 0x02 | 0x08 | 0x20, 0664, 0); // write, create, truncate
	foStream.write(output, output.length);
	foStream.close();

	/* show file contents to user, if connected to program it will open in that program
  	 * otherwise it will show in the sidebar. That sucks and needs to be corrected.
  	 */
  var handled = false;
  if( window.navigator.platform.substring(0,3) == 'Mac' )
  {
    try 
    { 
      // create an nsILocalFile for the executable 
      var file = Components.classes["@mozilla.org/file/local;1"] 
                                   .createInstance(Components.interfaces.nsILocalFile); 
      file.initWithPath("/usr/bin/open"); 
        
      if( file.exists() )
      {
        // create an nsIProcess 
        var process = Components.classes["@mozilla.org/process/util;1"] 
                                     .createInstance(Components.interfaces.nsIProcess); 
        process.init(file); 
        var args = [];
        if( send_bluetooth )
        {
          args.push("-a")
          args.push("/Applications/Utilities/Bluetooth File Exchange.app" );
        }
        args.push( url.replace( /file:\/\//, '' ) );
        process.run(false, args, args.length); 
        handled = true;
      }
    } 
    catch (e) 
    { 
       console.log(e);
    }
  }
  if( ! handled )
  {
	  window.location.replace(url);
  }
}
