var hcalendar = {
  className: "vevent",
  classAttribute: "class",
  classValue:     "vevent",

  xulFile: "chrome://tailsexport/content/microformats/hcalendar/hcalendar.xul",

  xslFile: "chrome://tailsexport/content/microformats/hcalendar/xhtml2vcal.xsl",

  mfogeo: function(vevent)
  { 
	if(vevent.geolat && vevent.geolon )
	{
		return true;
	}
	
	return false;
  },

  mfoextension: "vcs",

  mfoexport: true,
 
  processChildNode: function(node, vevent) {
    if (isElementOfClass(node, "class", "url"))
      vevent["url"] = fullUrl(node.ownerDocument, node.getAttribute("href"));
    
    mfo_setPropsFromAttr(node, vevent, ["dtstart", "dtend"], "title");
    mfo_setProps(node, vevent, ["summary","location","comment", "description", "location", "contact", "sequence", "priority", "dtstamp", "last-modified", "created", "recurrence-id", "attendee", "organizer"]);

    if (isElementOfClass(node, "class", "latitude"))
    {
	var geolat = node.getAttribute("title");
	if(!geolat) geolat = mfo_text(node);

	vevent["geolat"] = geolat;
    }

    if (isElementOfClass(node, "class", "longitude"))
    {
	var geolon = node.getAttribute("title");
	if(!geolon) geolon = mfo_text(node);

	vevent["geolon"] = geolon;
    }
  },

  add: function(formatObj) {
    for (var i=0; i<__tailsMFO.length; i++) {
      if (__tailsMFO[i].className == this.className && __tailsMFO[i].summary == formatObj.summary)
        return false;
    }
    return true;
  },

  populate: function(hcalendar, win) {
    setLabelValue(win, "hcalendar_summary" , hcalendar.summary);
    setLabelValue(win, "hcalendar_location", hcalendar.location);
    setButtonValue(win, "hcalendar_url"    , null, hcalendar.url);

    var date = hcalendar.dtstart;
    if (hcalendar.dtend) date += " - " + hcalendar.dtend;
    setLabelValue(win, "hcalendar_date" , date);

    hcalendar.logo = "chrome://tailsexport/content/microformats/hcalendar/calendar.gif";

    
    hcalendar.geolabel = "";

    if ( hcalendar['location'] ) { hcalendar.geolabel = hcalendar.geolabel+hcalendar.location; }
    else if ( hcalendar['summary'] ) { hcalendar.geolabel = hcalendar.geolabel+hcalendar.summary; }

    if ( date ) { hcalendar.geolabel = hcalendar.geolabel+", "+date; }

  }
};
