/* EVENT LISTENERS */
/*
 * Check if HTML document and somethig I don't quite yet understand.
 * If there are MFOs present make the statusbar ico green, else grey.
 * Save the status in a tab variable.
 */
function onPageShow(event) 
{
  var present, tab;

  if (event.originalTarget instanceof HTMLDocument)
  {
    if (!event.originalTarget.defaultView.frameElement
	&& isCurrentTab(getTabForDocument(event.originalTarget)))
    {
      present = MFOsPresent(event.originalTarget);

      tab = getTabForDocument(event.originalTarget);
      if (tab) { tab.__tailsContainsMicroformats = present; }

      setStatusbarImageTooltip(present);
    }
  }
}

/*
 * Set the statusbar according to the saved tab variable.
 */
function onTabChanged(event) 
{
  var tab;

  tab = window.top.getBrowser().selectedTab.linkedBrowser;

  if(tab) { setStatusbarImageTooltip(tab.__tailsContainsMicroformats); }
}

/* FUNCTIONS */
/* 
 * Check for each MFO if there is one present, if one found
 * then we can stop searching.
 */
function MFOsPresent(doc)
{
  var i, j, re, MFOs;

  var formats = getAllFormats();

  for (j=0; j<formats.length; j++) 
  {
    if( getDefault(formats[j].className) )
    {
      MFOs = document.evaluate("//*[contains(@"+formats[j].classAttribute+", '"+formats[j].classValue+"')]", doc, null, XPathResult.UNORDERED_NODE_SNAPSHOT_TYPE, null);
  
      re = new RegExp("\\b"+formats[j].classValue+"\\b");

      // ensure nodes are not just substring matches
      for (i=0; i<MFOs.snapshotLength; i++) 
      {
        if (MFOs.snapshotItem(i).getAttribute(formats[j].classAttribute).match(re)) { return true; }
      }
    }
  }

  return false;
}


/*
 * Toggle the statusbar image. The stringbundle is used ensure localization.
 */
function setStatusbarImageTooltip(mfo_present)
{
  var strbundle=document.getElementById("strings");

  if(mfo_present)
  {
	$_("tailsexport-status-image").setAttribute("src", "chrome://tailsexport/content/logo_on.gif");
	$_("tailsexport-status-image").setAttribute("tooltiptext", strbundle.getString("MFO"));
  }
  else
  {
	$_("tailsexport-status-image").setAttribute("src", "chrome://tailsexport/content/logo_off.gif");
	$_("tailsexport-status-image").setAttribute("tooltiptext", strbundle.getString("noMFO"));
  }
}

/* 
 * handle page load, focus change (back + forward button) and tab change [select]
 */
function init() 
{
  window.top.getBrowser().addEventListener("load", onPageShow, true);
  window.top.getBrowser().addEventListener("pageshow", onPageShow, true);
  window.top.getBrowser().tabContainer.addEventListener("select", onTabChanged, true);
}

/* MAIN */
init();
