var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);


function onPageLoad() 
{
  var j, value, label, item;

  var formats = getAllFormats();

  var strbundle=document.getElementById("strings");

  for (j=0; j<formats.length; j++) 
  {
	label = strbundle.getString("options.show")+" "+formats[j].className;

	if( formats[j].mfoexport )
	{
		label = label + " " + strbundle.getString("options.export");
	}

	value = getDefault(formats[j].className);
	
	makeItem(formats[j].className, value, label);
  }

  item = getElementByClassName(document, "checkbox", "exportFormats");
  value = getDefault("exportFormats");
  item.setAttribute("checked", value);

  item = getElementByClassName(document, "checkbox", "showLocation");
  value = getDefault("showLocation");
  item.setAttribute("checked", value);

  item = getElementByClassName(document, "checkbox", "showSourceHTML");
  value = getDefault("showSourceHTML");
  item.setAttribute("checked", value);

  item = getElementByClassName(document, "checkbox", "showExportResult");
  value = getDefault("showExportResult");
  item.setAttribute("checked", value);  
}

function getDefault(prefName)
{
	var value;

	prefName = "tailsexport."+prefName;

	if( prefs.prefHasUserValue(prefName) )
	{
		value = prefs.getCharPref(prefName);
	}
	else
	{
		value = "true";
	}

	return value;
}

function makeItem(class, value, label)
{
	var menu = getElementByClassName(document, "vbox", "formatsShowOptions");

    	var item = document.createElement("checkbox");

	item.setAttribute("class", class);
	item.setAttribute("checked", value)
	if( label ) { item.setAttribute("label", label ); }

	menu.appendChild(item);
}

function setDefaults()
{
  var j, item, value, prefName;

  var formats = getAllFormats();

  for (j=0; j<formats.length; j++) 
  {
	item = getElementByClassName(document, "checkbox", formats[j].className);
	value = item.getAttribute("checked");

	prefName = "tailsexport."+item.getAttribute("class");
	prefs.setCharPref(prefName, value);
  }

  item = getElementByClassName(document, "checkbox", "exportFormats");
  value = item.getAttribute("checked");
  
  prefName = "tailsexport."+item.getAttribute("class");
  prefs.setCharPref(prefName, value);

  item = getElementByClassName(document, "checkbox", "showLocation");
  value = item.getAttribute("checked");

  prefName = "tailsexport."+item.getAttribute("class");
  prefs.setCharPref(prefName, value);

  item = getElementByClassName(document, "checkbox", "showSourceHTML");
  value = item.getAttribute("checked");

  prefName = "tailsexport."+item.getAttribute("class");
  prefs.setCharPref(prefName, value);

  item = getElementByClassName(document, "checkbox", "showExportResult");
  value = item.getAttribute("checked");

  prefName = "tailsexport."+item.getAttribute("class");
  prefs.setCharPref(prefName, value);
}